/*
 * Format specification of some I3 packets.
 * If I3_VALIDATE_PACKETS is defined, packets that occur in the PSTYPE mapping
 * have their data validated on proper types.
 */
#define PSTYPE ([\
  "startup-req-2":({T_INT, T_INT, T_INT, T_INT, T_INT, T_INT, T_STRING, T_STRING, T_STRING, T_STRING, T_STRING, T_STRING, T_MAPPING, T_MAPPING}),\
  "startup-req-3":({T_INT, T_INT, T_INT, T_INT, T_INT, T_INT, T_STRING, T_STRING, T_STRING, T_STRING, T_STRING, T_STRING, T_MAPPING, T_MAPPING}),\
  "shutdown":({T_INT}),\
  "tell":({T_STRING, T_STRING}),\
  "emote":({T_STRING, T_STRING}),\
  "who-reply":({T_ARRAY}),\
  "who_data":({T_ARRAY}),\
  "user_data":({T_STRING, T_INT, T_STRING}),\
  "finger-req":({T_STRING}),\
  "finger-reply":({T_STRING, T_STRING, T_STRING, T_STRING, T_STRING, T_INT, T_STRING, T_STRING, T_STRING}),\
  "locate-req":({T_STRING}),\
  "locate-reply":({T_STRING, T_STRING, T_INT, T_STRING}),\
  "ucache-update":({T_STRING, T_STRING, T_INT}),\
])


#define PSNAME ([\
  "startup-req-2":({"password","old_mudlist_id","old_chanlist_id","player_port","imud_tcp_port" ,"imud_udp_port","mudlib","base_mudlib","driver","mud_type","open_status","admin_email","services","other_data"}),\
  "startup-req-3":({"password","old_mudlist_id","old_chanlist_id","player_port","imud_tcp_port","imud_udp_port","mudlib","base_mudlib","driver","mud_type","open_status","admin_email","services","other_data"}),\
  "shutdown":({"restart_delay"}),\
  "tell":({"orig_visname","message"}),\
  "emote":({"orig_visname","message"}),\
  "who-reply":({"who_data"}),\
  "who_data":({"user_data"}),\
  "user_data":({"user_visname","idle_time","xtra_info"}),\
  "finger-req":({"username"}),\
  "finger-reply":({"visname","title","real_name","e_mail","loginout_time","idle_time","ip_name","level","extra"}),\
  "locate-req":({"username"}),\
  "locate-reply":({"located_mudname","located_visname","idle_time","status"}),\
  "ucache-update":({"username","visname","gender"}),\
])
