#ifndef INTERMUD3_DOT_H
#define INTERMUD3_DOT_H

#include <intermud.h>

#define MUD_NAME  "Way of the Force"
#define LIB_NAME  "WOTFlib"
#define LIB_VERSION "0.90"

#define ADMIN_EMAIL ("/kernel/servers/sysconf"->query_admin_email())

#define LOGIN_PORT  3000
#define I3_TCP_PORT LOGIN_PORT + 2
#define I3_UDP_PORT LOGIN_PORT + 3

# define ERROR_BAD_PACKET        1
# define ERROR_PERMISSION_DENIED 2
# define ERROR_UNKNOWN_SERVICE   3
# define ERROR_BAD_DESTINATION   4
# define ERROR_BANNED            5
# define ERROR_NOT_AUTHENTICATED 6
# define ERROR_BAD_SOURCE        7
# define ERROR_TMP_DOWN          8
# define ERROR_DOWN              9
# define ERROR_INVALID_DESTINATION 10

#define ERRORDATA  ({({0,0}),\
                     ({"bad-pkt","Invalid packet"}),\
                     ({"not-allowed","Permission denied"}),\
                     ({"unk-type","Unknown packet type"}),\
                     ({"unk-dst","Unknown destination"}),\
                     ({"not-allowed","Your IP has been banned temporarely"}),\
                     ({"bad-proto","You need to authenticate first"}),\
                     ({"bad-src","Bad source for packet"}),\
                     ({"unk-dst","Destination is down, it said it would be back shortly"}),\
                     ({"unk-dst","Destination is down"}),\
                     ({"unk-dst","Invalid destination for this packet"}),\
                   })

#endif
